# CWL

## Organisation

### Runs

Every run is described with a `run.cwl` workflow that points to (i.e. steps through) one or multiple workflows or tools.

## Default cwltool commands

### Validate document

```bash
cwltool --validate run.cwl
```

### Execute workflow in `./runs/*`

```bash
cwltool run.cwl run.yml
```

### capture log and run in bg

```bash
cwltool run.cwl run.yml > $(date +"%Y-%m-%d_%H-%M")-run.log 2>&1 &
```

### capture log, run in parallel and in bg

```bash
cwltool --parallel run.cwl run.yml > $(date +"%Y-%m-%d_%H-%M")-run.log 2>&1 &
```

### Print workflow to file

```bash
cwltool --print-dot run.cwl | dot -Tsvg > run.svg
```

### List all workflows

```bash
find ./workflows -name 'workflow.cwl' -exec zsh -c 'echo "$1" >> workflows.txt' zsh {} \;
find ./workflows -name 'workflow.cwl' -exec zsh -c 'cwltool --validate "$1" > validate-workflows.txt' zsh {} \;
find ./runs -name 'run.cwl' -exec zsh -c 'cwltool --validate "$1" > validate-runs.txt' zsh {} \;
```